package com.develou.floating_context_menu

import android.os.Bundle
import android.view.ContextMenu
import android.view.Menu
import android.view.MenuItem
import android.view.View
import android.widget.ImageView
import android.widget.Toast
import androidx.appcompat.app.AppCompatActivity

class MainActivity : AppCompatActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        val image: ImageView = findViewById(R.id.image)
        registerForContextMenu(image)
    }

    override fun onCreateContextMenu(
        menu: ContextMenu,
        v: View,
        menuInfo: ContextMenu.ContextMenuInfo?
    ) {
        super.onCreateContextMenu(menu, v, menuInfo)

        menuInflater.inflate(R.menu.context_menu, menu)
        menu.setHeaderTitle(R.string.image_content_description)
        menu.add("Cambiar nombre").setOnMenuItemClickListener { item ->
            showMessage(item.title)
            true
        }
    }

    private fun showMessage(msg: CharSequence) {
        Toast.makeText(this, msg, Toast.LENGTH_SHORT).show()
    }

    override fun onContextItemSelected(item: MenuItem): Boolean {
        showMessage(item.title)

        return when (item.itemId) {
            R.id.download -> {
                download()
                true
            }
            R.id.share -> {
                share()
                true
            }
            R.id.copy -> {
                copy()
                true
            }
            else -> super.onContextItemSelected(item)
        }
    }

    private fun copy() {

    }

    private fun share() {

    }

    private fun download() {

    }

    override fun onContextMenuClosed(menu: Menu) {
        showMessage("Menú cerrado")
    }
}